#include <MacroPatternMatch.h>
#include "HROOTCoreTDictionary.h"
#include "TClass.h"
#include "HROOTCoreTClass.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TDICTIONARY_DEF_VIRT(TClass)
TNAMED_DEF_VIRT(TClass)
TOBJECT_DEF_VIRT(TClass)
DELETABLE_DEF_VIRT(TClass)

TCLASS_DEF_VIRT(TClass)

TCLASS_DEF_NONVIRT(TClass)

