{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttMarker.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.FFI
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITAttMarker TAttMarker where
        getMarkerColor = xform0 c_tattmarker_getmarkercolor
        getMarkerStyle = xform0 c_tattmarker_getmarkerstyle
        getMarkerSize = xform0 c_tattmarker_getmarkersize
        resetAttMarker = xform1 c_tattmarker_resetattmarker
        setMarkerAttributes = xform0 c_tattmarker_setmarkerattributes
        setMarkerColor = xform1 c_tattmarker_setmarkercolor
        setMarkerStyle = xform1 c_tattmarker_setmarkerstyle
        setMarkerSize = xform1 c_tattmarker_setmarkersize

instance IDeletable TAttMarker where
        delete = xform0 c_tattmarker_delete

newTAttMarker :: CInt -> CInt -> CInt -> IO TAttMarker
newTAttMarker = xform2 c_tattmarker_newtattmarker
