{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TObject.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.FFI
import HROOT.Core.TObject.Interface
import HROOT.Core.TObject.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITObject TObject where
        draw = xform1 c_tobject_draw
        findObject = xform1 c_tobject_findobject
        getName = xform0 c_tobject_getname
        isA = xform0 c_tobject_isa
        paint = xform1 c_tobject_paint
        printObj = xform1 c_tobject_printobj
        saveAs = xform2 c_tobject_saveas
        write = xform3 c_tobject_write

instance IDeletable TObject where
        delete = xform0 c_tobject_delete

newTObject :: IO TObject
newTObject = xformnull c_tobject_newtobject

tObjectGetObjectStat :: IO CInt
tObjectGetObjectStat = xformnull c_tobject_tobjectgetobjectstat
