{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TVirtualPad.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TVirtualPad.FFI
import HROOT.Core.TVirtualPad.Interface
import HROOT.Core.TVirtualPad.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITVirtualPad TVirtualPad where
        cd = xform1 c_tvirtualpad_cd
        divide_tvirtualpad = xform5 c_tvirtualpad_divide_tvirtualpad
        setLogx = xform1 c_tvirtualpad_setlogx
        setLogy = xform1 c_tvirtualpad_setlogy
        setLogz = xform1 c_tvirtualpad_setlogz

instance ITObject TVirtualPad where
        draw = xform1 c_tvirtualpad_draw
        findObject = xform1 c_tvirtualpad_findobject
        getName = xform0 c_tvirtualpad_getname
        isA = xform0 c_tvirtualpad_isa
        paint = xform1 c_tvirtualpad_paint
        printObj = xform1 c_tvirtualpad_printobj
        saveAs = xform2 c_tvirtualpad_saveas
        write = xform3 c_tvirtualpad_write

instance IDeletable TVirtualPad where
        delete = xform0 c_tvirtualpad_delete
