#include <MacroPatternMatch.h>
#include "HROOTCoreTObject.h"
#include "TVirtualPad.h"
#include "HROOTCoreTVirtualPad.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TOBJECT_DEF_VIRT(TVirtualPad)
DELETABLE_DEF_VIRT(TVirtualPad)

TVIRTUALPAD_DEF_VIRT(TVirtualPad)

TVIRTUALPAD_DEF_NONVIRT(TVirtualPad)

