{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttAxis.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TAttAxis.RawType
import HROOT.Core.TAttAxis.FFI
import HROOT.Core.TAttAxis.Interface
import HROOT.Core.TAttAxis.Cast
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITAttAxis TAttAxis where
        getNdivisions = xform0 c_tattaxis_getndivisions
        getAxisColor = xform0 c_tattaxis_getaxiscolor
        getLabelColor = xform0 c_tattaxis_getlabelcolor
        getLabelFont = xform0 c_tattaxis_getlabelfont
        getLabelOffset = xform0 c_tattaxis_getlabeloffset
        getLabelSize = xform0 c_tattaxis_getlabelsize
        getTitleOffset = xform0 c_tattaxis_gettitleoffset
        getTitleSize = xform0 c_tattaxis_gettitlesize
        getTickLength = xform0 c_tattaxis_getticklength
        getTitleFont = xform0 c_tattaxis_gettitlefont
        setNdivisions = xform2 c_tattaxis_setndivisions
        setAxisColor = xform1 c_tattaxis_setaxiscolor
        setLabelColor = xform1 c_tattaxis_setlabelcolor
        setLabelFont = xform1 c_tattaxis_setlabelfont
        setLabelOffset = xform1 c_tattaxis_setlabeloffset
        setLabelSize = xform1 c_tattaxis_setlabelsize
        setTickLength = xform1 c_tattaxis_setticklength
        setTitleOffset = xform1 c_tattaxis_settitleoffset
        setTitleSize = xform1 c_tattaxis_settitlesize
        setTitleColor = xform1 c_tattaxis_settitlecolor
        setTitleFont = xform1 c_tattaxis_settitlefont

instance IDeletable TAttAxis where
        delete = xform0 c_tattaxis_delete

newTAttAxis :: IO TAttAxis
newTAttAxis = xformnull c_tattaxis_newtattaxis
