{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttFill.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.FFI
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttFill.Cast
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITAttFill TAttFill where
        setFillColor = xform1 c_tattfill_setfillcolor
        setFillStyle = xform1 c_tattfill_setfillstyle

instance IDeletable TAttFill where
        delete = xform0 c_tattfill_delete

newTAttFill :: CInt -> CInt -> IO TAttFill
newTAttFill = xform1 c_tattfill_newtattfill
