{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttLine.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.FFI
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttLine.Cast
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITAttLine TAttLine where
        getLineColor = xform0 c_tattline_getlinecolor
        getLineStyle = xform0 c_tattline_getlinestyle
        getLineWidth = xform0 c_tattline_getlinewidth
        resetAttLine = xform1 c_tattline_resetattline
        setLineAttributes = xform0 c_tattline_setlineattributes
        setLineColor = xform1 c_tattline_setlinecolor
        setLineStyle = xform1 c_tattline_setlinestyle
        setLineWidth = xform1 c_tattline_setlinewidth

instance IDeletable TAttLine where
        delete = xform0 c_tattline_delete

newTAttLine :: CInt -> CInt -> CInt -> IO TAttLine
newTAttLine = xform2 c_tattline_newtattline

tAttLineDistancetoLine ::
                         TAttLine ->
                           CInt -> CInt -> CDouble -> CDouble -> CDouble -> CDouble -> IO CInt
tAttLineDistancetoLine = xform6 c_tattline_tattlinedistancetoline
