{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TClass.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.FFI
import HROOT.Core.TClass.Interface
import HROOT.Core.TClass.Cast
import HROOT.Core.TDictionary.RawType
import HROOT.Core.TDictionary.Cast
import HROOT.Core.TDictionary.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITClass TClass

instance ITDictionary TClass

instance ITNamed TClass where
        setName = xform1 c_tclass_setname
        setNameTitle = xform2 c_tclass_setnametitle
        setTitle = xform1 c_tclass_settitle

instance ITObject TClass where
        draw = xform1 c_tclass_draw
        findObject = xform1 c_tclass_findobject
        getName = xform0 c_tclass_getname
        isA = xform0 c_tclass_isa
        paint = xform1 c_tclass_paint
        printObj = xform1 c_tclass_printobj
        saveAs = xform2 c_tclass_saveas
        write = xform3 c_tclass_write

instance IDeletable TClass where
        delete = xform0 c_tclass_delete
